VERSION 5.00
Object = "{D01BD6BE-456A-4078-AEBF-3ACB85261FA6}#2.0#0"; "VCProX.ocx"
Begin VB.Form formMain 
   Caption         =   "Wave Pass Through"
   ClientHeight    =   2235
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   ScaleHeight     =   2235
   ScaleWidth      =   6030
   StartUpPosition =   3  'Windows Default
   Begin VCProX.vcproWaveCodecDeviceX waveCodec 
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   1560
      Width           =   1095
      Active          =   0   'False
      AutoActivate    =   -1  'True
      CalcVolume      =   0   'False
      DumpInput       =   ""
      DumpOutput      =   ""
      FormatTag       =   1
      FormatTagImmunable=   -1  'True
      InputIsPcm      =   -1  'True
      IsFormatProvider=   -1  'True
      OverNum         =   5
      PcmBitsPerSample=   16
      PcmNumChannels  =   2
      PcmSamplesPerSec=   44100
      RealTime        =   0   'False
   End
   Begin VCProX.vcproWaveRiffX waveWrite 
      Height          =   495
      Left            =   1440
      TabIndex        =   3
      Top             =   600
      Width           =   1095
      Active          =   0   'False
      AutoActivate    =   -1  'True
      CalcVolume      =   0   'False
      DumpInput       =   ""
      DumpOutput      =   ""
      IsFormatProvider=   0   'False
      OverNum         =   0
      PcmBitsPerSample=   16
      PcmNumChannels  =   2
      PcmSamplesPerSec=   44100
      FileName        =   ""
      IsInput         =   0   'False
      Loop            =   0   'False
      RealTime        =   0   'False
   End
   Begin VCProX.vcproWaveRiffX waveRead 
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1095
      Active          =   0   'False
      AutoActivate    =   0   'False
      CalcVolume      =   0   'False
      DumpInput       =   ""
      DumpOutput      =   ""
      IsFormatProvider=   -1  'True
      OverNum         =   5
      PcmBitsPerSample=   16
      PcmNumChannels  =   2
      PcmSamplesPerSec=   44100
      FileName        =   ""
      IsInput         =   -1  'True
      Loop            =   0   'False
      RealTime        =   0   'False
   End
   Begin VB.CommandButton button_set 
      Caption         =   "&Set Data"
      Height          =   375
      Left            =   3600
      TabIndex        =   4
      Top             =   600
      Width           =   1455
   End
   Begin VB.CommandButton button_get 
      Caption         =   "&Get Data"
      Height          =   375
      Left            =   3600
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
   Begin VB.TextBox edit_fileName 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Text            =   "J:\_data\_audio\Done.wav"
      Top             =   120
      Width           =   3255
   End
   Begin VB.Label label_info 
      Caption         =   "Label1"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1200
      Width           =   5775
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim dataChunk As Variant, dataSize As Integer, chunkCount As Integer
Private Sub SetLink(provider As VCProX.IvcproProvider, consumer As VCProX.IvcproConsumer)
    provider.AddConsumer consumer
End Sub

Private Sub waitASec()
        s = Second(Time)
        Do While 1 = 1
            ' wait
            If s <> Second(Time) Then
                Exit Do
            End If
        Loop
        '
End Sub

Private Sub button_get_Click()
    waveRead.FileName = edit_fileName.Text
    chunkCount = 0
    waveRead.Active = True
End Sub

Private Sub button_set_Click()
    If (1 = chunkCount) Then
        ' set same format for output as was in input
        waveWrite.PcmSamplesPerSec = waveCodec.PcmSamplesPerSec
        waveWrite.PcmBitsPerSample = waveCodec.PcmBitsPerSample
        waveWrite.PcmNumChannels = waveCodec.PcmNumChannels
        ' put data into file
        waveWrite.FileName = edit_fileName.Text & ".out.wav"
        waveWrite.Active = True
        waveWrite.SetData dataChunk
        ' wait a little
        waitASec
        waitASec
        ' and close the file
        waveWrite.Flush
        waveWrite.Active = False
        '
        label_info.Caption = "Saved " & dataSize & " bytes."
    Else
        label_info.Caption = "Get some data first."
    End If
End Sub

Private Sub Form_Load()
    SetLink waveRead.object, waveCodec.object
End Sub

Private Sub Form_Unload(Cancel As Integer)
    waveRead.Active = False
    waveWrite.Active = False
End Sub

Private Sub waveRead_OnDataAvailable()
    '
    If (0 = chunkCount) Then
        ' interested in first chunk only
        chunkCount = 1
        ' get our wave data into global var
        dataChunk = waveRead.GetData
        dataSize = Len(dataChunk)
        Dim vt As VbVarType
        Dim vt2 As VbVarType
        
        
        vt = VarType(dataChunk)
        vt2 = VarType(dataChunk(0))
        '
        label_info.Caption = "Got " & dataSize & " bytes. Press Set Data to write them into dest. file."
    End If
End Sub
